#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <linux/uaccess.h>
#include <linux/irq.h>
#include <asm/io.h>
#include <linux/device.h>


static struct class *leddrv_class;

static struct device *leddrv_class_dev[10];

volatile unsigned int *gpbcon[10];

static int led_drv_open(struct inode *inode, struct file *file)
{
	int i;
	for(i= 0; i < sizeof(gpbcon)/sizeof(gpbcon[0]); ++i){
		//printk("~~~~~~~~~~~~~~i = %d\n", i);
		//*gpbcon[i] &= ~(0x3 << 8);
		//*gpbcon[i] |= (0x1 << 9);
	}
	return 0;
}

static ssize_t led_drv_write(struct file *file, const char __user *buf, size_t count, loff_t * ppos)
{
	char str[12] = {0};
	unsigned long ret = copy_from_user(str, buf, count); 
	//bit0ǿhigh or low
	//bit8=0ʾoutput
	//bit9ʾinputҪoutput ʱbit80bit91(disable input)
		
	if(!strcmp(str, "led1on")){		// LED_1
		
		
		*gpbcon[0] &= 0xfffffffe;

	}
	else if(!strcmp(str, "led1off")){	// LED_1
	
		*gpbcon[0] |= 0x1;
		
	}
	
	else if(!strcmp(str, "led3on"))	{	//LED_3
		//*gpbcon[1] &= ~(0x3 << 8);
		//*gpbcon[1] |= (0x1 << 9);
		
		*gpbcon[1] &= 0xfffffffe;
	}
	else if(!strcmp(str, "led3off")){	//LED_3
	
		*gpbcon[1] |= 0x1;
	}
	
	else if(!strcmp(str, "led5on")){	//LED_5
		
		*gpbcon[2] &= 0xfffffffe;
		
	}
	else if(!strcmp(str, "led5off")){	//LED_5
	
		*gpbcon[2] |= 0x1;
		
	}
	else if(!strcmp(str, "led7on")){	//LED_7
		
		*gpbcon[3] &= 0xfffffffe;
		
	}
	else if(!strcmp(str, "led7off")){	//LED_7
		
		*gpbcon[3] |= 0x1;
		
	}
	else if(!strcmp(str, "led9on")){	//LED_9
	
		
		*gpbcon[4] &= 0xfffffffe;
		
	}
	else if(!strcmp(str, "led9off")){	//LED_9
		
		*gpbcon[4] |= 0x1;
	}
	else if(!strcmp(str, "led2on")){	//LED_2
	
		*gpbcon[5] |= 0x1;
	}
	else if(!strcmp(str, "led2off")){	//LED_2
		
		*gpbcon[5] &= 0xfffffffe;
	}
	else if(!strcmp(str, "led4on")){	//LED_4
		
		*gpbcon[6] |= 0x1;
	}
	else if(!strcmp(str, "led4off")){	//LED_4
		
		*gpbcon[6] &= 0xfffffffe;
	}
	else if(!strcmp(str, "led6on")){	//LED_6
			
		*gpbcon[7] |= 0x1;
	}
	else if(!strcmp(str, "led6off")){	//LED_6
	
		*gpbcon[7] &= 0xfffffffe;
	}
	else if(!strcmp(str, "led8on")){	//LED_8
		
		*gpbcon[8] |= 0x1;
	}
	else if(!strcmp(str, "led8off")){	//LED_8
	
		*gpbcon[8] &= 0xfffffffe;
	}
	
	else if(!strcmp(str, "led10on")){	//LED_10
	
		*gpbcon[9] |= 0x1;
	}
	else if(!strcmp(str, "led10off")){	//LED_10
		
		*gpbcon[9] &= 0xfffffffe;
	}
	return 0;
}

static struct file_operations led_drv_fops = {
    .owner  =   THIS_MODULE,    
    .open   =   led_drv_open,     
	.write	=	led_drv_write,	  		 
};
#define PCI_CFG_DATA    0xcfc
#define PCI_CFG_CTRL    0xcf8

static unsigned  int read_base(unsigned char offset)
{
	unsigned char fun = 0;
	unsigned char bus = 0;
	unsigned char dev = 0x0d;
	outl((0x80000000 | ((bus)<<16) |((dev)<<11) | ((fun)<<8) | (offset)), PCI_CFG_CTRL);
	unsigned  int  val = inl(PCI_CFG_DATA);
	printk("val 0x%x \n",val);
	if(val == 0xffffffff)
		return 0xD0000000;
	return val&0xfffff000;
}
int major, minor;
static int led_drv_init(void)
{

	int i;
	int err= 0;
	for( i = 0; i < sizeof(gpbcon)/sizeof(gpbcon[0]); ++i){
		 leddrv_class_dev[i] = NULL;
		 gpbcon[i] = NULL;
	}
 	unsigned  int base = read_base(0x10);
	printk("base 0x%x \n",base);
	major = register_chrdev(0, "led_drv", &led_drv_fops); 
	printk("major=== %d\n", major);

	if (major < 0) 
	{
		printk("led_drv: unable to get major number %d\n", major);
		goto out;
	}
	
	leddrv_class = class_create(THIS_MODULE, "leddrv_drv");
	if (IS_ERR(leddrv_class)) {
			err = PTR_ERR(leddrv_class);
			goto out_chrdev;
	}

	for( minor = 0; minor < sizeof(gpbcon)/sizeof(gpbcon[0]); ++minor)  
		leddrv_class_dev[minor] = device_create(leddrv_class, NULL, MKDEV(major, minor), NULL, "leddrv%d", minor + 1); 
	
	printk("base 0x%x  0x%x \n",base,0x92c50000);
#if 0
	
	base =  base+0xC50000;
	unsigned int *padd = ( unsigned int *)ioremap(base, 0xf00);// 0xD0C50000
	gpbcon[0] = padd+0x05B8/4;
	gpbcon[1] = padd+0x05C0/4;
	gpbcon[2] = padd+0x05C8/4;
	gpbcon[3] = padd+0x05D0/4;
	gpbcon[4] = padd+0x05D8/4;
	gpbcon[5] = padd+0x05E0/4;
	gpbcon[6] = padd+0x05E8/4;
	gpbcon[7] = padd+0x05F0/4;
	gpbcon[8] = padd+0x05F8/4;
	gpbcon[9] = padd+0x0600/4;


#else
	//base = 0x92000000;
	//printk("base2 0x%x: \n",base+0xC505B8);
	gpbcon[0]  =  (volatile unsigned int *)ioremap(base+0xC505B8, 1);    //GPIO23		LED_B_1

	gpbcon[1]  =  (volatile unsigned int *)ioremap(base+0xC505C0, 1);    //GPIO24
	
	gpbcon[2]  =  (volatile unsigned int *)ioremap(base+0xC505C8, 1);    //GPIO25
	
	gpbcon[3]  =  (volatile unsigned int *)ioremap(base+0xC505D0, 1);    //GPIO26		LED_B_7	  
	
	gpbcon[4]  =  (volatile unsigned int *)ioremap(base+0xC505D8, 1);    //GPIO27
	
	gpbcon[5]  =  (volatile unsigned int *)ioremap(base+0xC505E0, 1);    //GPIO28
	
	gpbcon[6]  =  (volatile unsigned int *)ioremap(base+0xC505E8, 1);    //GPIO29
	
	gpbcon[7]  =  (volatile unsigned int *)ioremap(base+0xC505F0, 1);    //GPIO30 
	
	gpbcon[8]  =  (volatile unsigned int *)ioremap(base+0xC505F8, 1);    //GPIO31		LED_R_8
	
	gpbcon[9]  =  (volatile unsigned int *)ioremap(base+0xC50600, 1);    //GPIO32		LED_R_10
    for(i=0;i<10;i++)
    {
        printk("gpbcon[%d]=0x%x val =0x%x\n",i,gpbcon[i],*gpbcon[i]); 
    }
	//0x2800
	int  *p =  (volatile unsigned int *)ioremap(0xD0C505Bc, 1);    //GPIO23	pull up
	*p |=0x2800;
#endif	
	err = 0;
	goto out;

	out_chrdev:
		unregister_chrdev(major, "led_drv");
	out:
		
        return err;
	return 0;
}

static void led_drv_exit(void)
{
	int i;
	unregister_chrdev(major, "led_drv"); 
	for( minor = 0; minor < sizeof(gpbcon)/sizeof(gpbcon[0]); ++minor)
		device_unregister(leddrv_class_dev[minor]);
	class_destroy(leddrv_class);
	
	for(i= 0; i < sizeof(gpbcon)/sizeof(gpbcon[0]); ++i)
		iounmap(gpbcon[i]);

}


module_init(led_drv_init);
module_exit(led_drv_exit);


MODULE_LICENSE("GPL"); // GPL
